/* These values must be defined for the benefit of the dispatch loop macros */
#define IX_EXCEPTION	0	; Return value to raise packet as exception
#define SA_CONSUME_NUM	31	; Only really check SA for packet 1 in 31 times
#define SEQNUM_IGNORE	31	; SA fastport seq num

/* These registers must be defined for the dispatch loop macros.  */
/* If you like I can send you the format for how they are used */
.local 	dl_reg1 dl_reg2 dl_reg3 dl_reg4 dl_buffer_handle dl_next_block

#include "DispatchLoop_h.uc"
#include "DispatchLoopImportVars.h"
#include "EthernetIngress.uc"
#include "wwbump_import.h"
#include "WWBump.uc"


; Microblock initialization 
DL_Init[]
EthernetIngress_Init[]
WWBumpInit[]

; CHANGE :  remove the tag altogether?
.local fixme
  immed32[fixme, WWBUMP_TAG]
.endlocal


.while(1)
DL_Start#:

	/* Get a frame from the StrongARM.  If there is none get one from the */
	/* microengines instead. */
	DL_SASource[ ]					; get next SA frame
	alu[--, dl_buffer_handle, -, IX_BUFFER_NULL]
	br=0[Main_Dispatch#], guess_branch	; We get NULL most of the time
	br[DL_MESink#]


Main_Dispatch#:

	/* Get an Ethernet frame.  If there is none, then go back to start */
	EthernetIngress[ ]				; Get Ethernet frame
	alu[--, dl_buffer_handle, -, IX_BUFFER_NULL]
	br=0[DL_Start#]

	/* If we got a frame, but Ethernet Ingress says to drop it, drop it */
	/* I'm not totally sure why we do this, but its in the Intel code */
	br!=byte[dl_next_block, 0, 1, DL_Drop#]

	/* Finally we run our microblock */
	WWBump[]

	/*
	  Now we check the return value of our microblock.  Possibilities : 
	  - exception :  send to StrongARM
	  - otherwise :  send to egress
	*/
	alu[ --, dl_next_block, -, IX_EXCEPTION]
	br=0[DL_SASink#]

	br[DL_MESink#]


DL_SASink#:
	/* Send the frame to the StrongARM as an exception */
	/* we assume that the tag and exception code have been assigned by */
	/* the microblock that told us to raise the frame as an exception */
	/* Start with another frame after we're done */
	DL_SASink[ ]
	.continue


DL_MESink#:
	/* Send the frame to the egress side.  We assume the "oface" (output */
	/* port) has been set by a microblock.  Start with a new frame  */
	/* when we are done */
	DL_MESink[ ]
	nop
	.continue

DL_Drop#:
	/* Drop the frame and start over getting a new one */
	DL_Drop[ ]

.endw

nop			; Intel style.  Not sure why these are here
nop
nop
.endlocal
